Skip to content
Start here

Add Account Custom Nameserver

POST/accounts/{account_id}/custom_ns

Add Account Custom Nameserver

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Account Settings Write
Path ParametersExpand Collapse
account_id: string

Account identifier tag.

maxLength32
Body ParametersJSONExpand Collapse
ns_name: string

The FQDN of the name server.

formathostname
ns_set: optional number

The number of the set that this name server belongs to.

maximum5
minimum1
ReturnsExpand Collapse
errors: array of { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional { pointer }
pointer: optional string
messages: array of { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional { pointer }
pointer: optional string
success: true

Whether the API call was successful.

result: optional CustomNameserver { dns_records, ns_name, status, 2 more }

A single account custom nameserver.

dns_records: array of { type, value }

A and AAAA records associated with the nameserver.

type: optional "A" or "AAAA"

DNS record type.

One of the following:
"A"
"AAAA"
value: optional string

DNS record contents (an IPv4 or IPv6 address).

ns_name: string

The FQDN of the name server.

formathostname
Deprecatedstatus: "moved" or "pending" or "verified"

Verification status of the nameserver.

One of the following:
"moved"
"pending"
"verified"
zone_tag: string

Identifier.

maxLength32
ns_set: optional number

The number of the set that this name server belongs to.

maximum5
minimum1

Add Account Custom Nameserver

curl https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/custom_ns \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \
    -d '{
          "ns_name": "ns1.example.com",
          "ns_set": 1
        }'
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "dns_records": [
      {
        "type": "A",
        "value": "1.1.1.1"
      }
    ],
    "ns_name": "ns1.example.com",
    "status": "verified",
    "zone_tag": "023e105f4ecef8ad9ca31a8372d0c353",
    "ns_set": 1
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "dns_records": [
      {
        "type": "A",
        "value": "1.1.1.1"
      }
    ],
    "ns_name": "ns1.example.com",
    "status": "verified",
    "zone_tag": "023e105f4ecef8ad9ca31a8372d0c353",
    "ns_set": 1
  }
}